#pragma once
#include "framework.h"
#include "chemistry factory.h"
#include <gl/gl.h>
#include <stdio.h>
#include <math.h>
#include <vector>
#include "windowsx.h"
#include "CSixTree.h"
#include "CmapGen.h"
#include "Cmenu.h"
using namespace std;
class Cconnect;
class CFont;

class CBase
{
	struct {
		CSixTree::Field::_sub_type object_type;
		int object_color = 0;
		int object_Count = 0;
		int lvl = 0;
	}misja;

	float _r, _g, _b;
	float object_X, object_Y, object_sX, object_sY, object_czoom, object_vzoom;

	float sinus[48];
	float cosinus[48];
	//mouse:
	bool control = false;
	bool shift = false;
	bool button_left = false;
	bool button_midle = false;
	bool button_right = false;
	short zDelta=0;//scroll
	short old_xPos, old_yPos;
	short xPos, yPos;

	int resx,resy;
	
	float zoom;
	float val;
	bool isInicjalized;
	HWND hWnd;
	HDC hDC;
	HGLRC hRC;
	float xxx, yyy;
	
	Cmenu* menu;
	
	int state_opengl;
	float line_with;
	void EnableOpenGL(HWND hWnd, HDC* hDC, HGLRC* hRC);
	void DisableOpenGL(HWND hWnd, HDC hDC, HGLRC hRC);
	bool DoIntersect(float x, float y, float sizex, float sizey, float xm, float ym);
	DWORD timer;
	DWORD timer2;
public:
	CBase(HWND hWnd);
	~CBase();

	bool Init();
	bool Render();
	bool PressedKey(WPARAM wParam);
	bool PressKeyAsync();
	bool MouseKey(UINT message, WPARAM wParam, WPARAM lParam);

	void DrawBox(float x, float y, float sx, float sy, float r, float g, float b);
	void DrawTriangle(float x, float y, float sx, float sy, float r, float g, float b);
	void DrawCircle(float x, float y, float fi1, float fi2, float r, float g, float b);
	void DrawLine(float x, float y, float sx, float sy, float fi, float r, float g, float b);
	void DrawTriangleFull(float xa, float ya, float xb, float yb, float xc, float yc, float r, float g, float b);
	void DrawArrow(CSixTree::Field::_kierunek kier);

	CSixTree::Field* Selected;//zaznaczony objekt resource only
	CSixTree::Field* Selected_all;//zaznaczony objekt all
	CmapGen* tree;
	Cconnect* connect;
	CFont* font;
	float posX, posY;
	float real_posX, real_posY;
};

void GetDesktopResolution(int& horizontal, int& vertical);

