#pragma once

class CmapGen
{
	struct Vector2D {
		Vector2D(int _x, int _y)
		{
			x = _x; y = _y;
		}
		int x, y;
	};
	vector<Vector2D> old_positions;
	

	
	struct {
		float top;
		float bottom;
		float left;
		float right;
	}Boundaries;

	struct {
		int top;
		int bottom;
		int left;
		int right;
	}Count;

	int DoIntersect(int x, int y, int sizex, int sizey) {//0 fail 1,2,3,4 top,bottom,left,right
		if (Boundaries.top >= (y - sizey / 2))
			return 1;
		if (Boundaries.bottom <= (y + sizey / 2))
			return 2;
		if (Boundaries.left >= (x - sizex / 2))
			return 3;
		if (Boundaries.right <= (x + sizex / 2))
			return 4;
		return 0;
	}
public:
	CmapGen();
	~CmapGen();

	bool CreateMap();
	vector<CSixTree::Field*>* GetArea(int x, int y, int sizex, int sizey);//left top corner position

	CSixTree* node;
	float GetRandom();//0...1
};

