#pragma once
#include "framework.h"
#include "chemistry factory.h"
#include <gl/gl.h>
#include <stdio.h>
#include <math.h>
#include <vector>
#include "windowsx.h"
#include "CSixTree.h"
#include "CmapGen.h"
using namespace std;
class CBase;

class Cmenu
{
	bool button_left = false;
	short zDelta = 0;//scroll
	short xPos, yPos;
	CBase* base;
	int resx, resy;
	int belt_x, belt_y;
	bool wasbelt = false;
	bool wasbelt2 = false;
	CSixTree::Field::_kierunek kier = CSixTree::Field::_kierunek::up;

	bool DoBoxesIntersect(int sx, int sy, int ex, int ey, int esizex, int esizey) {
		for( int x = ex; x < ex+ esizex; x++)
			for (int y = ey; y < ey + esizey; y++)
			{
				if ((x == sx) && (y == sy))
					return true;
			}
		return false;
	}
public:
	Cmenu();
	~Cmenu();

	bool Init(int _resx, int _resy, CBase* _base);
	bool Render();
	bool PressedKey(WPARAM wParam);
	bool MouseKey(UINT message, WPARAM wParam, WPARAM lParam);
	void DrawIcon(int i);
	bool ActionIcon(int i);

	int button_select = -1;
	int button_actual_select = -1;
	CSixTree::Field::_kierunek kierunek = CSixTree::Field::_kierunek::up;//0-up 1 right 2 bottom 3 right
	int object_posx, object_posy;
};