#pragma once
#pragma warning(disable : 26812)



class CSixTree
{
	bool last;
public:
	struct Field {
		struct color{ 
			float r = 0; float g = 0; float b = 0; 
			color() {};
			color(unsigned char _r, unsigned char _g, unsigned char _b){
				r = ((float)_r)/255.0F; g = ((float)_g) / 255.0F; b = ((float)_b) / 255.0F;
			};
		};
		enum class _type {
			Resource = 0,
			Bulding = 1
		}type;
		enum class _sub_type {
			None = -1,
			//shapes
			Triangle = 0,
			Square = 1,
			//colors base
			Red = 2,
			Yellow = 3,
			Blue = 4,
			//bludings
			Painter = 5,
			Paint_Mixer = 6,//to do
			Output = 8,
			Belt = 9,
			Spliter = 10,
			Miner = 11,
			Under_belt_input = 12,
			Under_belt_output = 13
		}sub_type;
		//painter
		struct Paint {
			int Paint_num=0;
			int count=0;
		};
		vector<Paint*> paint;
		_sub_type Paint_objtype = _sub_type::None;//triangle/box
		//position
		int posx, posy;
		int sizex=1, sizey=1;
		int Count=0;
		enum _kierunek {
			up = 0, right = 1, bottom = 2, left = 3
		}kierunek;
		
		//objekt on belt
		_sub_type belt_objtype= _sub_type::None;
		float belt_pos = 0.0F;
		float time_pass = 0.0F;
		size_t belt_next_pos = 0;
		vector<Field*> belt_next;
		vector<Field*> Targeted;
		int belt_object_color = -1;//object color
		Field* miner = 0;
	};
	int size;//this tree size
	int posx, posy;
private:
	vector<CSixTree::Field*> field;//reusable
	// 0 1 2
	// 3 4 5
	// 6 7 8
	CSixTree *tree[9];
	vector<CSixTree::Field*> fields;
	CSixTree(int size, int tx, int ty);
	bool DoBoxesIntersect(CSixTree *a, CSixTree *b) {
		return (abs(a->posx - b->posx) * 2 <= (a->size + b->size)) &&
			(abs(a->posy - b->posy) * 2 <= (a->size + b->size));
	}
	bool DoBoxesIntersect(CSixTree *a, int x, int y, int sizex, int sizey) {
		return (abs(a->posx - x) * 2 < (a->size + sizex)) &&
			(abs(a->posy - y) * 2 < (a->size + sizey));
	}
	bool DoBoxesIntersect(int sx, int sy, int ex, int ey, int esizex, int esizey) {
		for( int x = ex; x < ex+ esizex; x++)
			for (int y = ey; y < ey + esizey; y++)
			{
				if ((x == sx) && (y == sy))
					return true;
			}
		return false;
	}

public:
	CSixTree();
	CSixTree(CSixTree* first);
	~CSixTree();

	vector<CSixTree::Field*>* GetFields(Field::_sub_type type);
	void AddField(Field* field);
	void RemoveField(Field* field);
	vector<CSixTree::Field*> * GetArea(int x,int y, int sizex,int sizey);
	bool TestCords(int x, int y);
};

