#include "framework.h"
#include "chemistry factory.h"
#include <gl/gl.h>
#include <stdio.h>
#include <math.h>
#include <vector>
using namespace std;
#include "windowsx.h"
#include "CSixTree.h"
#include "CmapGen.h"
#include "Cmenu.h"
#include "CBase.h"
#include "Cconnect.h"



Cmenu::Cmenu()
{

}

Cmenu::~Cmenu()
{

}

bool Cmenu::Init(int _resx, int _resy, CBase* _base)
{
	resx = _resx;
	resy = _resy;
	base = _base;
	return true;
}

bool Cmenu::ActionIcon(int i)
{
	switch (i)
	{
	case 0://belt

		break;
	case 33://belt
		base->posX = 0.01375F;
		base->posY = 0.015556F;
		base->real_posX = 0.42F;
		base->real_posY = 0.46F;
		break;
	case 34://exit
		return true;
		break;
	}
	return false;
}

void Cmenu::DrawIcon(int i)
{
	float fix = 0.05f;
	float res = (float)resx / (float)resy;
	float r, g, b;
	fix /= res;
	float object_X = fix * i + 0.005f;
	float object_Y = 0.958f;
	float object_sX = 0.021f;
	float object_sY = 0.030f;
	switch (i)
	{
	case 0://belt
		base->DrawBox(fix * i + 0.005f, 0.958f, 0.021f, 0.030f, 0.2f, 0.2f, 0.2f);
		base->DrawBox(fix * i + 0.005f, 0.958f, 0.021f, 0.002f, 0.9f, 0.9f, 0.9f);
		base->DrawBox(fix * i + 0.005f, 0.986f, 0.021f, 0.002f, 0.9f, 0.9f, 0.9f);
		base->DrawLine(fix * i + 0.008f, 0.973f, fix * i + 0.013f, 0.980f, 3, 0.9f, 0.9f, 0.9f);
		base->DrawLine(fix * i + 0.008f, 0.973f, fix * i + 0.013f, 0.966f, 3, 0.9f, 0.9f, 0.9f);
		base->DrawLine(fix * i + 0.018f, 0.973f, fix * i + 0.023f, 0.980f, 3, 0.9f, 0.9f, 0.9f);
		base->DrawLine(fix * i + 0.018f, 0.973f, fix * i + 0.023f, 0.966f, 3, 0.9f, 0.9f, 0.9f);
		break;
	case 1://miner
		r = b = g = 0.6f;
		base->DrawBox(fix * i + 0.005f, 0.955f, 0.021f, 0.003f, r,g,b);
		base->DrawBox(fix * i + 0.005f, 0.955f, 0.0025f, 0.036f, r, g, b);
		base->DrawBox(fix * i + 0.005f, 0.955f+ 0.036f, 0.021f, -0.003f, r, g, b);
		base->DrawBox(fix * i + 0.005f+ 0.021f, 0.955f, -0.0025f, 0.036f, r, g, b);
		base->DrawLine(fix * i + 0.010f, 0.964f, fix * i + 0.020f, 0.980f, 3, 0.9f, 0.9f, 0.9f);
		base->DrawLine(fix * i + 0.010f, 0.980f, fix * i + 0.020f, 0.966f, 3, 0.9f, 0.9f, 0.9f);
		break;
	case 2://Painter
		r = b = g = 0.6f;
		base->DrawBox(fix * i + 0.005f, 0.955f, 0.021f, 0.003f, r, g, b);
		base->DrawBox(fix * i + 0.005f, 0.955f + 0.036f, 0.021f, -0.003f, r, g, b);
		base->DrawTriangleFull(fix * i + 0.005f, 0.955f, fix * i + 0.005f+0.01F, 0.955f, fix * i + 0.005f+0.005F, 0.955f + 0.01F,r,g,b);
		base->DrawTriangleFull(fix * i + 0.005f+0.01F, 0.955f, fix * i + 0.005f + 0.02F, 0.955f, fix * i + 0.005f + 0.015F, 0.955f+0.01F, r, g, b);
		base->DrawBox(fix * i + 0.005 + 0.005F, 0.955f + 0.03F, 0.021f- 0.01F, 0.003f- +0.01F, r, g, b);
		base->DrawBox(fix * i + 0.005 + 0.01F, 0.955f + 0.03F, 0.021f - 0.015F, 0.003f - +0.01F, 0, 0.7F, 0);
		break;
	case 3://Spliter
		r = b = g = 0.6f;
		base->DrawBox(fix * i + 0.005f, 0.955f, 0.021f, 0.003f, r, g, b);
		base->DrawBox(fix * i + 0.005f, 0.955f, 0.0025f, 0.036f, r, g, b);
		base->DrawBox(fix * i + 0.005f + 0.021f, 0.955f, -0.0025f, 0.036f, r, g, b);
		base->DrawLine(fix * i + 0.010f, 0.964f, fix * i + 0.020f, 0.980f, 3, 0.9f, 0.9f, 0.9f);
		base->DrawLine(fix * i + 0.010f, 0.980f, fix * i + 0.020f, 0.966f, 3, 0.9f, 0.9f, 0.9f);
		break;
	case 4://Under belt belt input output jest 35
		base->DrawBox(fix * i + 0.005f, 0.958f, 0.021f, 0.030f, 0.2f, 0.2f, 0.2f);
		base->DrawBox(fix * i + 0.005f, 0.958f, 0.021f, 0.002f, 0.9f, 0.9f, 0.9f);
		base->DrawBox(fix * i + 0.005f, 0.986f, 0.021f, 0.002f, 0.9f, 0.9f, 0.9f);
		base->DrawLine(fix * i + 0.018f, 0.973f, fix * i + 0.023f, 0.980f, 3, 0.9f, 0.9f, 0.9f);
		base->DrawLine(fix * i + 0.018f, 0.973f, fix * i + 0.023f, 0.966f, 3, 0.9f, 0.9f, 0.9f);
		base->DrawBox(fix * i + 0.005f, 0.958f, 0.010f, 0.030f, 0.7f, 0.7f, 0.5f);
		base->DrawLine(fix * i + 0.008f, 0.973f, fix * i + 0.013f, 0.980f, 3, 0.9f, 0.9f, 0.9f);
		base->DrawLine(fix * i + 0.008f, 0.973f, fix * i + 0.013f, 0.966f, 3, 0.9f, 0.9f, 0.9f);
		break;
	case 5://Paint_Mixer
		r = b = g = 0.6f;
		base->DrawBox(fix * i + 0.005f, 0.955f, 0.021f, 0.003f, r, g, b);
		base->DrawBox(fix * i + 0.005f, 0.955f + 0.036f, 0.021f, -0.003f, r, g, b);
		base->DrawBox(fix * i + 0.005f, 0.955f, 0.0025f, 0.036f, r, g, b);

		base->DrawTriangleFull(fix * i + 0.008f, 0.955f, fix * i + 0.008f + 0.01F, 0.955f, fix * i + 0.008f + 0.005F, 0.955f + 0.01F, r, g, b);
		base->DrawTriangleFull(fix * i + 0.008f + 0.01F, 0.955f, fix * i + 0.008f + 0.02F, 0.955f, fix * i + 0.008f + 0.015F, 0.955f + 0.01F, r, g, b);

		base->DrawTriangleFull(fix * i + 0.008f			, 0.955f + 0.036f	, fix * i + 0.008f + 0.01F	, 0.955f + 0.036f	, fix * i + 0.008f + 0.005F	, 0.955f - 0.01F + 0.036f, r, g, b);
		base->DrawTriangleFull(fix * i + 0.008f + 0.01F	, 0.955f + 0.036f	, fix * i + 0.008f + 0.02F	, 0.955f + 0.036f	, fix * i + 0.008f + 0.015F	, 0.955f - 0.01F + 0.036f, r, g, b);
		break;
	case 33://Base
		r = g = 0.7f;
		b = 0.1f;
		base->DrawBox(object_X , object_Y , object_sX , object_sY , r, g, b);
		r = g = b = 0.2f;
		base->DrawTriangleFull(object_X, object_Y, object_X + object_sX / 3, object_Y, object_X, object_Y + object_sY / 3, r, g, b);
		base->DrawTriangleFull(object_X + object_sX, object_Y, object_X + object_sX - object_sX / 3, object_Y, object_X + object_sX, object_Y + object_sY / 3, r, g, b);
		base->DrawTriangleFull(object_X, object_Y + object_sY - object_sY / 3, object_X, object_Y + object_sY, object_X + object_sX / 3, object_Y + object_sY, r, g, b);
		base->DrawTriangleFull(object_X + object_sX, object_Y + object_sY, object_X + object_sX, object_Y + object_sY - object_sY / 3, object_X + object_sX - object_sX / 3, object_Y + object_sY, r, g, b);
		break;
	case 34://exit		
		base->DrawLine(fix * i + 0.005f, 0.955f, fix * i + 0.005f + 0.021f, 0.955f + 0.036f, 5, 0.7f, 0, 0.7f);
		base->DrawLine(fix * i + 0.005f, 0.955f + 0.036f, fix * i + 0.005f + 0.021f, 0.955f, 5, 0.7f, 0, 0.7f);
		break;
	}
	
}

bool Cmenu::Render()
{
	base->DrawBox(0, 0.95f, 1, 0.05f, 0.8f, 0.8f, 0.8f);
	float fix = 0.05f;
	float res = (float)resx / (float)resy;
	fix /= res;
	bool end = true;
	for (int i = 0; i < 35; i++)
	{
		base->DrawBox(fix * i + 0.005f, 0.955f, 0.025f, 0.04f, 0, 0, 0);//cien

		if ((button_select == i) && ( button_actual_select != i ))//mose hover
		{
			base->DrawBox(fix * i + 0.003f, 0.953f, 0.025f, 0.04f, 0.7f, 0, 0);
			base->DrawBox(fix * i + 0.005f, 0.955f, 0.021f, 0.036f, 0, 0, 0.7f);
		}
		else
			if ((button_select != i) && (button_actual_select == i))//selected
			{
				base->DrawBox(fix * i + 0.003f, 0.953f, 0.025f, 0.04f, 0, 0.7F, 0);
				base->DrawBox(fix * i + 0.005f, 0.955f, 0.021f, 0.036f, 0, 0, 0.7f);
			}
			else
				if ((button_select == i) && (button_actual_select == i))
				{
					base->DrawBox(fix * i + 0.003f, 0.953f, 0.025f, 0.04f, 0.7f, 0, 0);
					base->DrawBox(fix * i + 0.004f, 0.954f, 0.023f, 0.038f, 0, 0.7F, 0);
					base->DrawBox(fix * i + 0.005f, 0.955f, 0.021f, 0.036f, 0, 0, 0.7f);
				}
		else
			base->DrawBox(fix * i + 0.003f, 0.953f, 0.025f, 0.04f, 0, 0, 0.7f);
		DrawIcon(i);
	}
	return end;
}

bool Cmenu::PressedKey(WPARAM wParam)
{
	return false;//quit game if true
}

bool Cmenu::MouseKey(UINT message, WPARAM wParam, WPARAM lParam)
{
	short fwKeys = GET_KEYSTATE_WPARAM(wParam);
	zDelta = GET_WHEEL_DELTA_WPARAM(wParam);
	xPos = GET_X_LPARAM(lParam);
	yPos = GET_Y_LPARAM(lParam);

	if (message == WM_LBUTTONDOWN)
		button_left = true;

	if((message == WM_LBUTTONUP) ||(message == WM_MOUSELEAVE))
	{
		wasbelt = false;
		//belt_x, belt_y;
		button_left = false;
	}

	float x = (xPos / (float)resx);
	float y = (yPos / (float)resy);

	float fix = 0.05f;
	float res = (float)resx / (float)resy;
	fix /= res;
	if (y >= 0.955F)
		button_select = -1;
	for (int i = 0; i < 35; i++)
	{
		if ((x > (fix * i + 0.005f)) && (y > 0.955f) && (x < (0.03f + fix * i)) &&  (y < 0.995f))
		{
			button_select = i;
		}
	}
	if (button_left)
	{
		if (y >= 0.955F)
			button_actual_select = button_select;
		if (y >= 0.955F)
			return ActionIcon(button_select);
		if ( (base->Selected != 0) && (button_actual_select == 1) )//miner
		{
			CSixTree::Field* objekt = new CSixTree::Field;
			memcpy(objekt, base->Selected, sizeof(CSixTree::Field));
			objekt->type = CSixTree::Field::_type::Bulding;
			objekt->sub_type = CSixTree::Field::_sub_type::Miner;
			objekt->kierunek = kierunek;
			base->connect->ConnectObject(objekt);
			base->tree->node->AddField(objekt);
		}
		if((button_actual_select == 3) && (base->Selected_all == 0))//Spliter
		{
			CSixTree::Field* objekt = new CSixTree::Field;
			objekt->posx = object_posx;
			objekt->posy = object_posy;
			objekt->type = CSixTree::Field::_type::Bulding;
			objekt->sub_type = CSixTree::Field::_sub_type::Spliter;
			objekt->kierunek = kierunek;
			base->connect->ConnectObject(objekt);
			base->tree->node->AddField(objekt);
		}
		if ((button_actual_select == 2) && (base->Selected_all == 0))//Peinter
		{
			CSixTree::Field* objekt = new CSixTree::Field;
			objekt->posx = object_posx;
			objekt->posy = object_posy;
			objekt->type = CSixTree::Field::_type::Bulding;
			objekt->sub_type = CSixTree::Field::_sub_type::Painter;
			objekt->kierunek = kierunek;
			base->connect->ConnectObject(objekt);
			base->tree->node->AddField(objekt);
		}
		if ((button_actual_select == 5) && (base->Selected_all == 0))//Paint_Mixer
		{
			CSixTree::Field* objekt = new CSixTree::Field;
			objekt->posx = object_posx;
			objekt->posy = object_posy;
			objekt->type = CSixTree::Field::_type::Bulding;
			objekt->sub_type = CSixTree::Field::_sub_type::Paint_Mixer;
			objekt->kierunek = kierunek;
			base->connect->ConnectObject(objekt);
			base->tree->node->AddField(objekt);
		}
		if ((button_actual_select == 4) || (button_actual_select == 35))//Under belt
		{
			int xx = object_posx;
			int yy = object_posy;
			if (wasbelt)
				if (kier != kierunek)
					wasbelt = false;
				else
				{
					if ((kierunek == CSixTree::Field::_kierunek::up) || (kierunek == CSixTree::Field::_kierunek::bottom))
						xx = belt_x;
					if ((kierunek == CSixTree::Field::_kierunek::right) || (kierunek == CSixTree::Field::_kierunek::left))
						yy = belt_y;
				}
			CSixTree::Field* objekt = 0;
			vector<CSixTree::Field*>* temp = base->tree->node->GetArea(xx, yy, 1, 1);
			for (int i = 0; i < temp->size(); i++)
			{
				CSixTree::Field* field = temp->at(i);
				if (DoBoxesIntersect(xx, yy, field->posx, field->posy, field->sizex, field->sizey))
				{
					if (field->type != CSixTree::Field::_type::Resource)
						return false;//is object uder it but not compatible
				}
			}
			if ((button_actual_select == 35) && (wasbelt) )
			{
				if (abs(belt_x - xx) + abs(belt_y - yy) < 5)
				{
					return false;
				}
			}
			objekt = new CSixTree::Field;
			objekt->posx = xx;
			objekt->posy = yy;
			objekt->type = CSixTree::Field::_type::Bulding;
			if (button_actual_select == 4)
			{
				objekt->sub_type = CSixTree::Field::_sub_type::Under_belt_input;
				button_actual_select = 35;

			}
			else
			{
				objekt->sub_type = CSixTree::Field::_sub_type::Under_belt_output;
				button_actual_select = 4;
			}
			objekt->kierunek = kierunek;

			base->connect->ConnectObject(objekt);
			base->tree->node->AddField(objekt);

			if (button_actual_select == 35)
			{
				belt_x = objekt->posx;
				belt_y = objekt->posy;
			}

			if (!wasbelt)
			{
				belt_x = objekt->posx;
				belt_y = objekt->posy;
				wasbelt = true;
				kier = kierunek;
			}
		}

		if(button_actual_select == 0)//belt
		{
			int xx = object_posx;
			int yy = object_posy;
			if (wasbelt)
				if (kier != kierunek)
					wasbelt = false;
				else
				{
					if ((kierunek == CSixTree::Field::_kierunek::up) || (kierunek == CSixTree::Field::_kierunek::bottom))
						xx = belt_x;
					if ((kierunek == CSixTree::Field::_kierunek::right) || (kierunek == CSixTree::Field::_kierunek::left))
						yy = belt_y;
				}
			bool isBeltUnder = false;
			CSixTree::Field* objekt = 0;
			vector<CSixTree::Field*>* temp = base->tree->node->GetArea(xx, yy, 1, 1);
			for (int i = 0; i < temp->size(); i++)
			{
				CSixTree::Field* field = temp->at(i);
				if (DoBoxesIntersect(xx,yy, field->posx, field->posy, field->sizex, field->sizey))
				{
					if ((field->sub_type == CSixTree::Field::_sub_type::Belt) && (field->kierunek != kierunek))
					{
						isBeltUnder = true;
						objekt = field;
					}
					else
					{
						if (field->type != CSixTree::Field::_type::Resource)
							return false;//is object uder it but not compatible
					}
				}
			}
			
			if (!isBeltUnder)
				objekt = new CSixTree::Field;
			
			objekt->posx = xx;
			objekt->posy = yy;
			objekt->type = CSixTree::Field::_type::Bulding;
			objekt->sub_type = CSixTree::Field::_sub_type::Belt;
			objekt->kierunek = kierunek;
			if (!isBeltUnder)
			{
				base->connect->ConnectObject(objekt);
				base->tree->node->AddField(objekt);
			}
			else
			{
				base->connect->DisconnectObject(objekt);
				base->connect->ConnectObject(objekt);
				//no need to add is alerady there
			}
			if (!wasbelt)
			{
				belt_x = objekt->posx;
				belt_y = objekt->posy;
				wasbelt = true;
				kier = kierunek;
			}
		}
	}
	return false;//quit game if true
}